Index: /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 8774)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 8775)
@@ -125,4 +125,5 @@
     <EmbeddedResource Include="Documents\PSO_Schwefel.hl" />
     <EmbeddedResource Include="Documents\TS_VRP.hl" />
+    <EmbeddedResource Include="Documents\SS_VRP.hl" />
     <None Include="Plugin.cs.frame" />
     <Compile Include="DefineArithmeticProgressionDialog.cs">
@@ -340,5 +341,5 @@
   -->
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -347,5 +348,5 @@
 call PreBuildEvent.cmd
 </PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs	(revision 8774)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/SamplesTest.cs	(revision 8775)
@@ -28,4 +28,5 @@
 using HeuristicLab.Algorithms.LocalSearch;
 using HeuristicLab.Algorithms.ParticleSwarmOptimization;
+using HeuristicLab.Algorithms.ScatterSearch;
 using HeuristicLab.Algorithms.SimulatedAnnealing;
 using HeuristicLab.Algorithms.TabuSearch;
@@ -57,4 +58,5 @@
 using HeuristicLab.Problems.VehicleRouting.ProblemInstances;
 using HeuristicLab.Selection;
+using HeuristicLab.SequentialEngine;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
@@ -950,4 +952,58 @@
     #endregion
 
+    #region Scatter Search
+    #region VRP
+    [TestMethod]
+    public void CreateScatterSearchVRPSampleTest() {
+      var ss = CreateScatterSearchVRPSample();
+      XmlGenerator.Serialize(ss, "../../SS_VRP.hl");
+    }
+
+    [TestMethod]
+    public void RunScatterSearchVRPSampleTest() {
+      var ss = CreateScatterSearchVRPSample();
+      ss.SetSeedRandomly.Value = false;
+      RunAlgorithm(ss);
+      Assert.AreEqual(749, GetDoubleResult(ss, "BestQuality"));
+      Assert.AreEqual(766.95, GetDoubleResult(ss, "CurrentAverageQuality"));
+      Assert.AreEqual(789, GetDoubleResult(ss, "CurrentWorstQuality"));
+      Assert.AreEqual(27400, GetIntResult(ss, "EvaluatedSolutions"));
+    }
+
+    private ScatterSearch CreateScatterSearchVRPSample() {
+      #region Problem Configuration
+      var provider = new AugeratInstanceProvider();
+      var instance = provider.GetDataDescriptors().Where(x => x.Name == "A-n38-k5").Single();
+      VehicleRoutingProblem vrpProblem = new VehicleRoutingProblem();
+      vrpProblem.Load(provider.LoadData(instance));
+      #endregion
+
+      #region Algorithm Configuration
+      ScatterSearch ss = new ScatterSearch();
+      ss.Engine = new SequentialEngine();
+      ss.Name = "Scatter Search - VRP";
+      ss.Description = "A Scatter Search algorithm which solves the \"A-n38-k5\" vehicle routing problem (imported from Augerat)";
+      ss.Problem = vrpProblem;
+
+      var improver = ss.Problem.Operators.OfType<VRPImprovementOperator>().First();
+      improver.ImprovementAttemptsParameter.Value.Value = 5;
+      improver.SampleSizeParameter.Value.Value = 5;
+      ss.Improver = improver;
+
+      var pathRelinker = ss.Problem.Operators.OfType<VRPPathRelinker>().First();
+      pathRelinker.IterationsParameter.Value.Value = 15;
+      ss.PathRelinker = pathRelinker;
+
+      var qualitySimCalc = ss.SimilarityCalculatorParameter.ValidValues.OfType<QualitySimilarityCalculator>().First();
+      ss.SimilarityCalculator = qualitySimCalc;
+
+      ss.MaximumIterations.Value = 5;
+      ss.Seed.Value = 0;
+      return ss;
+      #endregion
+    }
+    #endregion
+    #endregion
+
     #region Helpers
     private void ConfigureEvolutionStrategyParameters<R, M, SC, SR, SM>(EvolutionStrategy es, int popSize, int children, int parentsPerChild, int maxGens, bool plusSelection)
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 8774)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 8775)
@@ -119,4 +119,10 @@
     <Reference Include="HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <HintPath>..\bin\HeuristicLab.Algorithms.ParticleSwarmOptimization-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Algorithms.RAPGA-3.3">
+      <HintPath>..\bin\HeuristicLab.Algorithms.RAPGA-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Algorithms.ScatterSearch-3.3">
+      <HintPath>..\bin\HeuristicLab.Algorithms.ScatterSearch-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Algorithms.SimulatedAnnealing-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">