Index: /branches/DynamicVehicleRouting/HeuristicLab.PDPSimulation/3.3/Parsers/DefaultDynPDPParser.cs
===================================================================
--- /branches/DynamicVehicleRouting/HeuristicLab.PDPSimulation/3.3/Parsers/DefaultDynPDPParser.cs	(revision 8794)
+++ /branches/DynamicVehicleRouting/HeuristicLab.PDPSimulation/3.3/Parsers/DefaultDynPDPParser.cs	(revision 8795)
@@ -47,9 +47,9 @@
           Vehicle v = new Vehicle();
 
-          v.xCoord = double.Parse(m[0].Value);
-          v.yCoord = double.Parse(m[1].Value);
-          v.capacity = double.Parse(m[2].Value);
-          v.readyTime = double.Parse(m[3].Value);
-          v.dueTime = double.Parse(m[4].Value);
+          v.xCoord = double.Parse(m[0].Value, System.Globalization.CultureInfo.InvariantCulture);
+          v.yCoord = double.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture);
+          v.capacity = double.Parse(m[2].Value, System.Globalization.CultureInfo.InvariantCulture);
+          v.readyTime = double.Parse(m[3].Value, System.Globalization.CultureInfo.InvariantCulture);
+          v.dueTime = double.Parse(m[4].Value, System.Globalization.CultureInfo.InvariantCulture);
 
           vehicles.Add(v);
@@ -64,16 +64,16 @@
           Order o = new Order();
 
-          o.revealedTime = double.Parse(m[0].Value);
-          o.pickupXCoord = double.Parse(m[1].Value);
-          o.pickupYCoord = double.Parse(m[2].Value);
-          o.deliveryXCoord = double.Parse(m[3].Value);
-          o.deliveryYCoord = double.Parse(m[4].Value);
-          o.demand = double.Parse(m[5].Value);
-          o.pickupServiceTime = double.Parse(m[6].Value);
-          o.pickupReadyTime = double.Parse(m[7].Value);
-          o.pickupDueTime = double.Parse(m[8].Value);
-          o.deliveryServiceTime = double.Parse(m[9].Value);
-          o.deliveryReadyTime = double.Parse(m[10].Value);
-          o.deliveryDueTime = double.Parse(m[11].Value);
+          o.revealedTime = double.Parse(m[0].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.pickupXCoord = double.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.pickupYCoord = double.Parse(m[2].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.deliveryXCoord = double.Parse(m[3].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.deliveryYCoord = double.Parse(m[4].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.demand = double.Parse(m[5].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.pickupServiceTime = double.Parse(m[6].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.pickupReadyTime = double.Parse(m[7].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.pickupDueTime = double.Parse(m[8].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.deliveryServiceTime = double.Parse(m[9].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.deliveryReadyTime = double.Parse(m[10].Value, System.Globalization.CultureInfo.InvariantCulture);
+          o.deliveryDueTime = double.Parse(m[11].Value, System.Globalization.CultureInfo.InvariantCulture);
 
           orders.Add(o);
Index: /branches/DynamicVehicleRouting/HeuristicLab.PDPSimulation/3.3/Parsers/TSPLibDynPDPParser.cs
===================================================================
--- /branches/DynamicVehicleRouting/HeuristicLab.PDPSimulation/3.3/Parsers/TSPLibDynPDPParser.cs	(revision 8794)
+++ /branches/DynamicVehicleRouting/HeuristicLab.PDPSimulation/3.3/Parsers/TSPLibDynPDPParser.cs	(revision 8795)
@@ -59,6 +59,6 @@
         m = reg.Matches(line);
         while (m.Count == 3) {
-          xCoord.Add(double.Parse(m[1].Value));
-          yCoord.Add(double.Parse(m[2].Value));
+          xCoord.Add(double.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture));
+          yCoord.Add(double.Parse(m[2].Value, System.Globalization.CultureInfo.InvariantCulture));
 
           line = reader.ReadLine();
@@ -84,14 +84,14 @@
           Order o = new Order();
 
-          int pickupId = int.Parse(m[1].Value);
-          int deliveryId = int.Parse(m[2].Value);
-          double pickupTWOpen = double.Parse(m[3].Value);
-          double pickupTWClose = double.Parse(m[4].Value);
-          double pickupServiceTime = double.Parse(m[5].Value);
-          double deliveryTWOpen = double.Parse(m[6].Value);
-          double deliveryTWClose = double.Parse(m[7].Value);
-          double deliveryServiceTime = double.Parse(m[8].Value);
-          double demand = double.Parse(m[9].Value);
-          double revealed = double.Parse(m[10].Value);
+          int pickupId = int.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture);
+          int deliveryId = int.Parse(m[2].Value, System.Globalization.CultureInfo.InvariantCulture);
+          double pickupTWOpen = double.Parse(m[3].Value, System.Globalization.CultureInfo.InvariantCulture);
+          double pickupTWClose = double.Parse(m[4].Value, System.Globalization.CultureInfo.InvariantCulture);
+          double pickupServiceTime = double.Parse(m[5].Value, System.Globalization.CultureInfo.InvariantCulture);
+          double deliveryTWOpen = double.Parse(m[6].Value, System.Globalization.CultureInfo.InvariantCulture);
+          double deliveryTWClose = double.Parse(m[7].Value, System.Globalization.CultureInfo.InvariantCulture);
+          double deliveryServiceTime = double.Parse(m[8].Value, System.Globalization.CultureInfo.InvariantCulture);
+          double demand = double.Parse(m[9].Value, System.Globalization.CultureInfo.InvariantCulture);
+          double revealed = double.Parse(m[10].Value, System.Globalization.CultureInfo.InvariantCulture);
 
           o.revealedTime = revealed;